--[[******************************************
*
*	Multi Theft Auto - Player renamer
*
*	playerrenamer.lua
*
*	Made by [DRuG]Dabombber and [DRuG]KillFrenzy
*
**********************************************]]

local root = getRootElement( )

function checkname ( player )
	local ClientName = getPlayerName ( player )
	if ( ClientName == "Player" or string.find ( ClientName , "^Player%(%d+%)$" ) ) then
		local AccountName = getPlayerUserName ( player ) : sub ( 0 , 16 ) : gsub ( " " , "_" )
		if ( AccountName ) then
			if ( getPlayerFromName ( AccountName ) ) then
				renamealt ( player )
			else
				if ( not setPlayerName ( player , AccountName ) ) then
					outputConsole ( "PLAYER RENAMER: Unable to rename " .. ClientName .. " to " .. AccountName )
				end
			end
		else
			renamealt ( player )
		end
	end
end

function renamealt ( player )
	local i = 0
	local AccountName
	while ( true ) do --loop breaks when player is renamed
		i = i + 1
		AccountName = "Player(" .. tostring(i) .. ")"
		if not ( getPlayerFromName ( AccountName ) ) then
			if ( not setPlayerName ( player , AccountName ) ) then
				outputConsole ( "PLAYER RENAMER: Unable to rename " .. getPlayerName ( player ) .. " to " .. AccountName )
			end
			break
		end
	end
end

addEventHandler( "onPlayerJoin" , root ,
	function ( )
		checkname ( source )
	end
)
addEventHandler( "onResourceStart" , root ,
	function ( startedResource )
		if ( startedResource == getThisResource ( ) ) then
			for id , player in ipairs ( getElementsByType( "player" ) ) do
				checkname ( player )
			end
		end
	end	
)

addCommandHandler ( "rename" ,
	function ( player , commandName , targetplayer , newname )
		if ( hasObjectPermissionTo ( player , "function.setPlayerName" , false ) ) then
			if ( targetplayer ) then
				local sauce = getElementType ( player )
				local target = FindPlayer ( targetplayer )
				if ( target ) then
					if ( target == player ) then
						outputChatBox ( "rename: Use the /nick command to rename yourself" , player , 255 , 168 , 0 )
					else
						local oldname = getPlayerName ( target )
						if ( setPlayerName ( target , newname ) ) then
--							if ( sauce == "player" ) then
--								outputChatBox ( "rename: " .. oldname "'s name has been changed to " .. newname, player , 100 , 100 , 255 )
--								outputServerLog( "rename: " .. getPlayerName ( player ) .. " changed " .. oldname .. "'s name to " .. newname )		
--							elseif ( sauce == "console" ) then
--								outputServerLog( "rename: " .. oldname .. "'s name has been changed to " .. newname )		
--							end
						else
							if ( sauce == "player" ) then
								outputChatBox ( "rename: Unable to change " .. oldname "'s name to " .. newname, player , 100 , 100 , 255 )
							elseif ( sauce == "console" ) then
								outputServerLog( "rename: Unable to change " .. oldname .. "'s name to " .. newname )		
							end
						end
					end
				else
					if ( sauce == "player" ) then
						outputChatBox ( "rename: Player not found" , player , 255 , 0 , 0 )
					elseif ( sauce == "console" ) then
						outputServerLog( "rename: Player not found" )
					end
				end
			else
				if ( sauce == "player" ) then
					outputChatBox ( "rename: Usage /rename player newname" , player , 255 , 168 , 0 )
				elseif ( sauce == "console" ) then
					outputServerLog( "rename: Usage /rename player newname" )
				end
			end
		else
			outputChatBox ( "You do not have permission to change names" , player , 255 , 0 , 0 )
		end
	end
 )
 
 function FindPlayer ( text )
	local player = getPlayerFromName ( text )
	if ( player ) then return player end
	local lowtext = string.lower ( text )
	for id , player in ipairs ( getElementsByType ( "player" ) ) do
		if ( string.find ( string.lower ( getPlayerName ( player ) ), lowtext , 1 , true ) ) then
			return player
		end
	end
	return false
end
